<script setup lang="ts">
import CopyToClipboardIcon from "@/components/CopyToClipboardIcon.vue";
import { computed, onMounted, reactive, watch } from "vue";
import { createDownloadUrl } from "@/utils/DownloadJson";
import type { ClowmInfo } from "@/types/ClowmInfo";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useWorkflowStore } from "@/stores/workflows";
import { DocumentationEnum } from "@/client/types.gen";
import DraggableLists from "@/components/DraggableLists.vue";
import ParameterInput from "@/components/parameter-schema/form-mode/ParameterInput.vue";

const props = defineProps<{
  workflowId?: string;
  workflowVersionId?: string;
}>();

const workflowRepository = useWorkflowStore();

const infoState = reactive<ClowmInfo>({
  inputParameters: [],
  outputParameters: [],
  exampleParameters: undefined,
  dois: undefined,
  resourceParameters: undefined,
});

const parameterPools = reactive<{
  input: string[];
  output: string[];
  resources: string[];
  examples: string[];
}>({
  examples: [],
  input: [],
  output: [],
  resources: [],
});

// eslint-disable-next-line @typescript-eslint/no-explicit-any
const parameterSchema = computed<Record<string, Record<string, any>>>(() => {
  const schema =
    workflowRepository.documentationFiles[props.workflowVersionId ?? ""]?.[
      "parameter_schema.json"
    ];
  const a = schema?.["properties"] ?? {};
  for (const group in schema?.["definitions"] ?? {}) {
    for (const param in schema?.["definitions"]?.[group]?.["properties"] ??
      {}) {
      a[param] = schema["definitions"][group]["properties"][param];
    }
  }
  return a;
});

function getParameterType(param: string): string | undefined {
  return parameterSchema.value[param]?.["type"];
}

const infoStateString = computed<string>(() =>
  JSON.stringify(infoState, null, 2),
);
const downloadUrl = computed<string>(() =>
  createDownloadUrl(infoStateString.value, "application/json"),
);

watch(
  () => workflowRepository.documentationFiles[props.workflowVersionId ?? ""],
  (newVal, old) => {
    if (newVal != old && newVal?.["parameter_schema.json"] != undefined) {
      updateParameterPools(newVal);
    }
  },
  {
    deep: true,
  },
);

// eslint-disable-next-line @typescript-eslint/no-explicit-any
function updateParameterPools(newVal?: Record<DocumentationEnum, any>) {
  if (newVal?.["parameter_schema.json"]) {
    const parameters = extractParameterList(newVal["parameter_schema.json"]);
    parameterPools.input = parameters.slice();
    parameterPools.output = parameters.slice();
    parameterPools.resources = parameters.slice();
    parameterPools.examples = parameters.slice();
    infoState.inputParameters = [];
    infoState.outputParameters = [];
    infoState.exampleParameters = undefined;
    infoState.resourceParameters = undefined;
  }
  if (
    newVal?.["clowm_info.json"] &&
    Object.keys(newVal["clowm_info.json"]).length > 0
  ) {
    Object.assign(
      infoState,
      JSON.parse(JSON.stringify(newVal["clowm_info.json"])),
    );
    parameterPools.input = parameterPools.input.filter(
      (param) => !infoState.inputParameters.includes(param),
    );
    parameterPools.resources = parameterPools.resources?.filter(
      (param) => !infoState.resourceParameters?.includes(param),
    );
    parameterPools.output = parameterPools.output.filter(
      (param) => !infoState.outputParameters.includes(param),
    );
    parameterPools.examples = parameterPools.examples?.filter(
      (param) =>
        !Object.keys(infoState.exampleParameters ?? {}).includes(param),
    );
  }
}

// eslint-disable-next-line @typescript-eslint/no-explicit-any
function extractParameterList(schema: Record<string, any>): string[] {
  const groupedParameters = Object.keys(schema["definitions"] ?? {}).reduce(
    (acc: string[], val) => [
      ...acc,
      ...Object.keys(schema["definitions"][val]["properties"]),
    ],
    [],
  );
  const singleParameters = Object.keys(schema["properties"] ?? {});
  return [...groupedParameters, ...singleParameters];
}

function addDoi() {
  if (infoState.dois == undefined) {
    infoState.dois = [""];
  } else {
    infoState.dois.push("");
  }
}

function removeDoi(index: number) {
  if (infoState.dois?.length === 1) {
    infoState.dois = undefined;
  }
  infoState.dois?.splice(index, 1);
}

function addExampleParameter(param: string, index: number) {
  if (infoState.exampleParameters == undefined) {
    infoState.exampleParameters = {};
  }
  parameterPools.examples.splice(index, 1);
  switch (getParameterType(param)) {
    case "integer": {
      infoState.exampleParameters[param] = 0;
      break;
    }
    case "number": {
      infoState.exampleParameters[param] = 0;
      break;
    }
    case "boolean": {
      infoState.exampleParameters[param] = true;
      break;
    }
    case "string": {
      infoState.exampleParameters[param] =
        parameterSchema.value[param]?.["enum"]?.[0] ?? "";
      break;
    }
    default: {
      infoState.exampleParameters[param] = "";
      break;
    }
  }
}

function deleteExampleParameter(param: string) {
  delete infoState.exampleParameters?.[param];
  parameterPools.examples.push(param);
  if (Object.keys(infoState.exampleParameters ?? {}).length === 0) {
    infoState.exampleParameters = undefined;
  }
}

onMounted(() => {
  if (props.workflowId && props.workflowVersionId) {
    Promise.all([
      workflowRepository.fetchWorkflowDocumentation(
        props.workflowId,
        props.workflowVersionId,
        DocumentationEnum.PARAMETER_SCHEMA_JSON,
      ),
      workflowRepository.fetchWorkflowDocumentation(
        props.workflowId,
        props.workflowVersionId,
        DocumentationEnum.CLOWM_INFO_JSON,
      ),
    ]).finally(() => {
      updateParameterPools(
        workflowRepository.documentationFiles[props.workflowVersionId!],
      );
    });
  }
});
</script>

<template>
  <div class="row border-bottom mb-4">
    <h2 class="mb-2">
      Add parameter metadata
      <template v-if="props.workflowId"
        >to
        {{ workflowRepository.workflowMapping[props.workflowId]?.name }}
      </template>
    </h2>
  </div>
  <div>
    Enhance your Workflow with CloWM specific parameter metadata to simplify the
    usability and increase the user experience of your workflow within CloWM.
    This can be achieved by simply adding a file named
    <code>clowm_info.json</code>, containing parameter metadata, into your
    repositories in a folder called <code>clowm</code>. With the provided
    metadata a workflow developer can provide
    <ul>
      <li>semantic meanings by parameter designation,</li>
      <li>example parameters to allow users a easy tryout of the workflow,</li>
      <li>and DOI links to publications and additional information</li>
    </ul>
    For guidance on creating file <code>clowm_info.json</code> please explore
    tabs below.
  </div>
  <div id="clowmInfoAccordion" class="accordion my-4">
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button
          class="accordion-button"
          type="button"
          data-bs-toggle="collapse"
          data-bs-target="#clowmInfoAccordion-input"
          aria-expanded="true"
          aria-controls="clowmInfoAccordion-input"
        >
          Designate input parameters
        </button>
      </h2>
      <div
        id="clowmInfoAccordion-input"
        class="accordion-collapse collapse show"
        data-bs-parent="#clowmInfoAccordion"
      >
        <div class="accordion-body">
          <p>
            <b>Designate Parameters as Input Files</b>: Assign semantic meaning
            to parameters by dragging them from the left side to the right side
            to designate them as input files.
          </p>
          <draggable-lists
            :left-list="parameterPools.input"
            :right-list="infoState.inputParameters"
          >
            <template #leftHeader>Workflow parameters</template>
            <template #rightHeader>Selected input parameters</template>
          </draggable-lists>
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button
          class="accordion-button collapsed"
          type="button"
          data-bs-toggle="collapse"
          data-bs-target="#clowmInfoAccordion-output"
          aria-expanded="false"
          aria-controls="clowmInfoAccordion-output"
        >
          Designate output parameters
        </button>
      </h2>
      <div
        id="clowmInfoAccordion-output"
        class="accordion-collapse collapse"
        data-bs-parent="#clowmInfoAccordion"
      >
        <div class="accordion-body">
          <p>
            <b>Designate Parameters as Output</b>: Assign semantic meaning to
            parameters by dragging them from the left side to the right side to
            designate them as output files.
          </p>
          <draggable-lists
            :left-list="parameterPools.output"
            :right-list="infoState.outputParameters"
          >
            <template #leftHeader>Workflow parameters</template>
            <template #rightHeader>Selected output parameters</template>
          </draggable-lists>
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button
          class="accordion-button collapsed"
          type="button"
          data-bs-toggle="collapse"
          data-bs-target="#clowmInfoAccordion-resource"
          aria-expanded="false"
          aria-controls="clowmInfoAccordion-resource"
        >
          Designate resource parameters
        </button>
      </h2>
      <div
        id="clowmInfoAccordion-resource"
        class="accordion-collapse collapse"
        data-bs-parent="#clowmInfoAccordion"
      >
        <div class="accordion-body">
          <p>
            <b>Designate Parameters as Resources</b>: Drag parameters from the
            left side to the right side to imbue them with semantic meaning as
            resource parameters. CloWM automatically generates a specialized
            form input for users to configure these parameters.
          </p>
          <button
            v-if="infoState.resourceParameters == undefined"
            type="button"
            class="btn btn-primary"
            @click="infoState.resourceParameters = []"
          >
            This workflow needs resources
          </button>
          <draggable-lists
            v-else
            :left-list="parameterPools.resources"
            :right-list="infoState.resourceParameters"
          >
            <template #leftHeader>Workflow parameters</template>
            <template #rightHeader>Selected resources parameters</template>
          </draggable-lists>
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button
          class="accordion-button collapsed"
          type="button"
          data-bs-toggle="collapse"
          data-bs-target="#clowmInfoAccordion-example"
          aria-expanded="false"
          aria-controls="clowmInfoAccordion-example"
        >
          Set example parameters
        </button>
      </h2>
      <div
        id="clowmInfoAccordion-example"
        class="accordion-collapse collapse"
        data-bs-parent="#clowmInfoAccordion"
      >
        <div class="accordion-body">
          <p>
            <b>Easy trial of a workflow</b>: Incorporate example parameters
            using publicly available test data. Easily achieve this by including
            a sample dataset in your Git repository and linking its URL as the
            input parameter.
          </p>
          <p>
            Guidance on Parameter Setting: Avoid specifying parameters that
            define output locations or resource paths, as these heavily depend
            on the user or execution environment.
          </p>
          <div
            class="d-flex flex-wrap overflow-y-auto p-1 border border-bottom-0 rounded-top border-dashed"
            style="max-height: 30vh"
          >
            <b class="ms-1 w-100">Workflow parameters:</b>
            <template v-if="parameterPools.examples.length > 0">
              <div
                v-for="(param, index) in parameterPools.examples"
                :key="param"
                class="w-fit border px-2 rounded cursor-pointer m-1 parameter-container"
                @click="addExampleParameter(param, index)"
              >
                {{ param }}
              </div>
            </template>
            <div v-else class="px-2 text-secondary m-1">
              <i>Empty</i>
            </div>
          </div>
          <table class="table table-bordered align-middle">
            <thead>
              <tr>
                <th scope="col"><b>Parameter</b></th>
                <th scope="col"><b>Value</b></th>
              </tr>
            </thead>
            <tbody v-if="infoState.exampleParameters">
              <tr
                v-for="param in Object.keys(infoState.exampleParameters)"
                :key="param"
              >
                <td style="width: 10%">{{ param }}</td>
                <td class="d-flex justify-content-between align-items-center">
                  <div class="flex-fill input-group">
                    <parameter-input
                      v-model="infoState.exampleParameters[param]"
                      :parameter="parameterSchema[param]"
                      size-modifier="sm"
                      force-raw-file
                    />
                  </div>
                  <button
                    type="button"
                    class="btn btn-outline-danger btn-sm ms-2"
                    @click="deleteExampleParameter(param)"
                  >
                    Remove
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button
          class="accordion-button collapsed"
          type="button"
          data-bs-toggle="collapse"
          data-bs-target="#clowmInfoAccordion-dois"
          aria-expanded="false"
          aria-controls="clowmInfoAccordion-dois"
        >
          DOIs
        </button>
      </h2>
      <div
        id="clowmInfoAccordion-dois"
        class="accordion-collapse collapse"
        data-bs-parent="#clowmInfoAccordion"
      >
        <div class="accordion-body">
          <p>
            <b>Document Object Identifier</b>: Add DOIs to your workflow. This
            will be used to generate link on your workflows dedicated page.
          </p>
          <button type="button" class="btn btn-primary" @click="addDoi">
            Add DOI
          </button>
          <div v-if="infoState.dois">
            <div
              v-for="(doi, index) in infoState.dois"
              :key="index"
              class="d-flex my-2"
            >
              <button
                type="button"
                class="btn btn-outline-danger btn-sm"
                @click="removeDoi(index)"
              >
                Remove
              </button>
              <input
                v-model="infoState.dois[index]"
                type="text"
                class="form-control mx-2"
                maxlength="48"
                style="max-width: 400px"
              />
              <div class="align-self-center">
                DOI Link:
                <a
                  :href="'https://doi.org/' + doi"
                  target="_blank"
                  class="align-self-center"
                  >https://doi.org/{{ doi }}
                  <font-awesome-icon
                    icon="fa-solid fa-arrow-up-right-from-square"
                    class="ms-1"
                  />
                </a>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <h5>Generated <code>clowm_info.json</code></h5>
  <pre class="rounded w-100"><code>{{ infoState }}</code></pre>
  <p>
    Add this file to your Git repository, commit and push your changes and
    register the new workflow version in CloWM
  </p>
  <copy-to-clipboard-icon button :text="infoStateString" />
  <a
    class="btn btn-primary btn-sm ms-2"
    :href="downloadUrl"
    download="clowm_info.json"
    >Download to file
    <font-awesome-icon icon="fa-solid fa-download" class="ms-1" />
  </a>
</template>

<style scoped>
.parameter-container:hover {
  background: var(--bs-secondary-bg-subtle);
}
</style>
